#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#define CPUINFO		"/proc/cpuinfo"
#define NELEMS(a)	(sizeof(a)/sizeof(a[0]))

char *prog_name;


extern void	apecs_info (void);
extern void	lca_info (void);


static struct platform {
    const char	*name;
    void	(*reporter)(void);
} platform[] = {
#if 0
    "Alcor",		alcor_info,
#endif
    {"Avanti",		apecs_info},
    {"Cabriolet",	apecs_info},
    {"EB64+",		apecs_info},
    {"EB66",		lca_info},
    {"EB66P",		lca_info},
    {"Mustang",		apecs_info},
    {"Noname",		lca_info},
};


void
main (int argc, char **argv)
{
    char name[256], value[256], *systype = 0;
    FILE *fp;
    int i;

    prog_name = argv[0];

    if (geteuid()) {
	fprintf(stderr, "%s: must be run as root (or setuid root)\n",
		prog_name);
	exit(1);
    }

    fp = fopen(CPUINFO, "r");
    systype = 0;
    while (fscanf(fp, "%256[^:]: %256[^\n]\n", name, value) == 2) {
	if (strncmp(name, "system type", 11) == 0) {
	    systype = value;
	    break;
	}
    }
    if (!systype) {
	fprintf(stderr, "%s: could not determine system type from %s\n",
		prog_name, CPUINFO);
	exit(1);
    }
    printf("This is a %s system.\n", systype);

    for (i = 0; i < NELEMS(platform); ++i) {
	if (strcmp(platform[i].name, systype) == 0) {
	    platform[i].reporter();
	    break;
	}
    }
}
